var canvas;
var cntx;

function init(){
	canvas=document.getElementById("visualisation");
    cntx=canvas.getContext("2d");
    
    showAppTitle();
    initialValues();
    initialiseGUI();
    initialiseEvents();
    drawBasicScreen();
}
      
function initialiseEvents(){
	$("#visualisation").on("mousemove touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseMove();
    });

    $("#visualisation").on("mouseup touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseUp();
    });

    $("#visualisation").on("mousedown touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseDown();
    });

    window.addEventListener("beforeunload",function(e){
        clearInterval(timerLoop);
    });
}

function initialiseGUI(){
    $("#HscrR1").attr("max",MaxR1);
    $("#HscrR2").attr("max",MaxR2);
    $("#HscrP").attr("max",MaxP);
    $("#HscrNoOfRotations").attr("max",MaxNoOfRotations);
    PaletteTop=$("#editTools").position().top+$("#ColorSchemes").position().top+PaletteSlotSize;
    $("#HscrR1").val(R);
    $("#lblR1").text(R);
    $("#HscrR2").val(r);
    $("#lblR2").text(r);
    $("#HscrP").val(r);
    $("#lblP").text(r);
    $("#HscrNoOfRotations").val(NoOfRotations);
    $("#lblNoOfRotations").text(NoOfRotations);
    $("#HScrDrawSpeed").val(490);
    $("#lblDrawSpeed").text(490);
    $("#HScrResolution").val(100);
}

function initialValues(){
    TitleTOP=20;
    TitleWIDTH=550;
    TitleLEFT=(width-TitleWIDTH)/2;
    TitleHEIGHT=35;
    imgLogo=document.getElementById("Logo");
    width=canvas.width;
    height=canvas.height;
    R=23;
    r=24;
    p=24;
    Xc1=544;
    Yc1=height/2;

    BottomPanelTop=height-BottomPanelHeight;
    logoLeft=width-logoWidth-5;
    logoTop=BottomPanelTop+(BottomPanelHeight-logoHeight)/2;
    imgNxtStepEnabled=document.getElementById("ButtonEnabledSmall");
    imgNxtStepSelected=document.getElementById("ButtonSelSmall");
    imgBackStepEnabled=document.getElementById("BackEnabledSmall");
    imgBackStepSelected=document.getElementById("BackSelSmall");
    nxtStepLeft=width-nxtStepWidth-15-logoWidth;
    nxtStepTop=BottomPanelTop+20;
    BackStepLeft=2;
    BackStepTop=nxtStepTop;
    $("#ColorSchemes").val("palette");
    initialisePalette();
}

function drawBasicScreen(){
    cntx.clearRect(0,0,canvas.width,canvas.height);
    //Εικόνες
    drawIntroImage();
    drawLogoImage();
    //Κουμπιά
    if(introStep<introSpirographStep){
    	$("#editTools").hide();
    	drawButtonNext();
    }
    else{
    	$("#editTools").show();
    }
    if(introStep>1){
    	drawButtonBack();
    }
	var promptYCoord=BottomPanelTop+25;
    if(introStep==introSpirographStep){
		if(SelectedColorScheme==1){
			drawPalette();
		}
        cnvsWrite("rgb(0,0,255)",fontSize,"Arial",50,promptYCoord,"Σύρε το ποντίκι σου πάνω από την παλέτα για να επιλέξεις χρώμα.");
        cnvsWrite("rgb(0,0,255)",fontSize,"Arial",50,promptYCoord+20,"Για να κατανοήσεις τη λειτουργία του Αλγόριθμου, μείωσε την Ταχύτητα Περιστροφής");
        cnvsWrite("rgb(0,0,255)",fontSize,"Arial",50,promptYCoord+40,"και ενεργοποίησε την εμφάνιση του Σπειρογράφου.");

    }
    if(introStep==introSpirographStep && spiroFinished){
        drawSpiro(0);
    }
}

function drawIntroImage(){
	Intro=document.getElementById("img"+introStep);
    var picTop=(height-Intro.height)/2;
    cntx.strokeStyle="black";
    //πλαίσιο καμβά
    cntx.rect(0,0,width,height);
    //άνω πλαίσιο
    cntx.rect(0,0,width,picTop-1);
    //κάτω πλαίσιο
    var lowRectTop=picTop+Intro.height+1;
    cntx.rect(0,lowRectTop,width,height-lowRectTop);

    cntx.stroke();
    cnvsWrite(LetterColor,35,"Arial",-1,TitleTOP+TitleHEIGHT,appTitle);
    cntx.drawImage(Intro,1,picTop);
}

function drawLogoImage(){
    var picTop=(height-Intro.height)/2;
    var lowRectTop=picTop+Intro.height+1;
    var logoTop=lowRectTop+((height-lowRectTop)-imgLogo.height)/2;
    cntx.drawImage(imgLogo,width-imgLogo.width-2,logoTop);
}

function showHTML(){
    window.open("index_DS_I_DS_II.html","_blank");
}

function drawButtonNext(){
    //Διαχείριση κουμπιού [Επόμενο Βήμα]
    if (buttonNextHover()){
        cntx.drawImage(imgNxtStepSelected,nxtStepLeft,nxtStepTop);
    }
    else{
        cntx.drawImage(imgNxtStepEnabled,nxtStepLeft,nxtStepTop);
    }
}

function buttonNextHover(){
    if (mx>=nxtStepLeft && mx<=nxtStepLeft+nxtStepWidth && my>=nxtStepTop && my<=nxtStepTop+nxtStepHeight){
        return true;
    }
    else {
        return false;
    }
}

function drawButtonBack(){
    //Διαχείριση κουμπιού [Επόμενο Βήμα]
    if (buttonBackHover()){
        cntx.drawImage(imgBackStepSelected,BackStepLeft,BackStepTop);
    }
    else{
        cntx.drawImage(imgBackStepEnabled,BackStepLeft,BackStepTop);
    }
}

function buttonBackHover(){
    if (mx>=BackStepLeft && mx<=BackStepLeft+BackStepWidth && my>=BackStepTop && my<=BackStepTop+BackStepHeight){
        return true;
    }
    else {
        return false;
    }
}

function cnvsWrite(clr,fontSize,fontName,txtX,txtY,txt){       
    if(fontName!=""){
    	cntx.font=fontSize+"px "+fontName;
    }
    if(clr!=""){
    	cntx.fillStyle=clr;
    }
    if(txtX<0) txtX=(canvas.width-cntx.measureText(txt).width)/2;
    cntx.fillText(txt,txtX,txtY);
}

function handleMouseDown(){
	if(introStep==introSpirographStep){

	}
}

function handleMouseMove(){
    if(mx>=logoLeft && mx<logoLeft+logoWidth && my>=logoTop && my<logoTop+logoHeight){
        imgLogo=document.getElementById("LogoSel");
    }
    else{
        imgLogo=document.getElementById("Logo");
    }
    
    canvas.style.cursor="default";
    if(introStep==introSpirographStep){
        if(SelectedColorScheme==1 && PaletteHover()){
        	canvas.style.cursor="pointer";
        }
    }

    if(!Drawing)drawBasicScreen();
    if(debug)console.log("mx="+mx+" , my="+my);
}

function handleMouseUp(){
    if(mx>=logoLeft && mx<logoLeft+logoWidth && my >=logoTop && my<logoTop+logoHeight){
        showHTML();
    }
    if(mx>=nxtStepLeft && mx<nxtStepLeft+nxtStepWidth && my>=nxtStepTop && my<nxtStepTop+nxtStepHeight && introStep<introSpirographStep){
        introStep++;
        if(introStep==introSpirographStep){
        	resetDrawingLoop();
        }
    }
    if(mx>=BackStepLeft && mx<BackStepLeft+BackStepWidth && my>=BackStepTop && my<BackStepTop+BackStepHeight && introStep>1){
        introStep--;
        Drawing=false;
        clearInterval(timerLoop);
    }
    
    if(introStep==introSpirographStep){
		if(SelectedColorScheme==1 && PaletteHover()){
			SelectPaletteColor();
		}
    }
    drawBasicScreen();
}

function rangeValueChanged(rangeID){
    if(rangeID=="HscrR1"){
        R=parseInt($("#HscrR1").val());
        $("#lblR1").text(R);
    }
    else if(rangeID=="HscrR2"){
        r=parseInt($("#HscrR2").val());
        $("#lblR2").text(r);
    }
    else if(rangeID=="HscrP"){
        p=parseInt($("#HscrP").val());
        $("#lblP").text(p);
    }
    else if(rangeID=="HscrNoOfRotations"){
        NoOfRotations=parseInt($("#HscrNoOfRotations").val());
        $("#lblNoOfRotations").text(NoOfRotations);
    }
    else if(rangeID=="HScrDrawSpeed"){
        //do nothing
    }
    else if(rangeID=="HScrResolution"){
      //do nothing
    }
    resetDrawingLoop();
}

function initialisePalette(){
	PaletteR[0]=0; PaletteG[0]=0; PaletteB[0]=0;
	PaletteR[1]=90; PaletteG[1]=90; PaletteB[1]=90;
	PaletteR[2]=255; PaletteG[2]=0; PaletteB[2]=0;
	PaletteR[3]=0; PaletteG[3]=255; PaletteB[3]=0;
	PaletteR[4]=0; PaletteG[4]=0; PaletteB[4]=255;
	PaletteR[5]=130; PaletteG[5]=0; PaletteB[5]=100;
	PaletteR[6]=240; PaletteG[6]=140; PaletteB[6]=70;
	PaletteR[7]=240; PaletteG[7]=80; PaletteB[7]=70;
	PaletteR[8]=160; PaletteG[8]=45; PaletteB[8]=170;
	PaletteR[9]=160; PaletteG[9]=45; PaletteB[9]=225;
	PaletteR[10]=100; PaletteG[10]=60; PaletteB[10]=200;
	PaletteR[11]=60; PaletteG[11]=130; PaletteB[11]=200;
	PaletteR[12]=60; PaletteG[12]=175; PaletteB[12]=200;
	PaletteR[13]=160; PaletteG[13]=175; PaletteB[13]=220;
	PaletteR[14]=210; PaletteG[14]=180; PaletteB[14]=150;
	PaletteR[15]=255; PaletteG[15]=255; PaletteB[15]=0;
}

function drawPalette(){
	for(var i=0;i<NoOfPaletteColors;i++){
		cntx.fillStyle="rgb("+PaletteR[i]+","+PaletteG[i]+","+PaletteB[i]+")";
		cntx.beginPath();
		cntx.fillRect(PaletteLeft+PaletteSlotSize*i,PaletteTop,PaletteSlotSize,PaletteSlotSize);
		cntx.fill();
	}
	cntx.strokeStyle="rgb(255,255,255)";
	var X1=PaletteLeft+PaletteSlotSize*SelectedColorIndex;
	var Y1=PaletteTop;
	var X2=X1+PaletteSlotSize;
	var Y2=Y1+PaletteSlotSize;
	cntx.beginPath();
	cntx.moveTo(X1,Y1);
	cntx.lineTo(X2,Y2);
	cntx.moveTo(X1,Y2);
	cntx.lineTo(X2,Y1);
	cntx.stroke();
}

function PaletteHover(){
    return (mx>=PaletteLeft && mx<PaletteLeft+NoOfPaletteColors*PaletteSlotSize && my>=PaletteTop && my<=PaletteTop+PaletteSlotSize);
}

function SelectPaletteColor(){
	SelectedColorIndex=parseInt((mx-PaletteLeft)/PaletteSlotSize);
	resetDrawingLoop();
}

function itemStateChanged(slctr){
    if(slctr=="ColorSchemes"){
        SelectedColorScheme=$("#ColorSchemes").prop("selectedIndex")+1;
        if(SelectedColorScheme==1){
            //do nothing
        }
        else if(SelectedColorScheme==2){
            //do nothing
        }
        else if(SelectedColorScheme==3){
            //do nothing
        }           
        else if(SelectedColorScheme==4){
            //do nothing
        }
        else if(SelectedColorScheme==5){
            defineRandomColors();
        }
        else if(SelectedColorScheme==6){
            defineRandomColors();
        }
        resetDrawingLoop();
    }
}

function drawPattern(){
    if(Drawing){
        if($("#HScrDrawSpeed").val()==$("#HScrDrawSpeed").attr("max")){
            //Αν ο χρήστης έχει επιλέξει τη μέγιστη ταχύτητα, σχεδίασε αμέσως όλο το σχήμα
            CurrentNoOfRotations=NoOfRotations;
        }
        else{
            CurrentNoOfRotations+=.1;
        }
        drawBasicScreen();
        drawSpiro(0);
        if(CurrentNoOfRotations>NoOfRotations){
            CurrentNoOfRotations=NoOfRotations;
            Drawing=false;
            spiroFinished=true;
        }
    }
}

function resetDrawingLoop(){
    clearInterval(timerLoop);
    CurrentNoOfRotations=0;
    spiroFinished=false;
    Drawing=true;
    var newSpeed=parseInt($("#HScrDrawSpeed").attr("max"))-parseInt($("#HScrDrawSpeed").val());
    timerLoop=setInterval(function(){drawPattern();},newSpeed);
}

function drawSpiro(StartingTheta){
    var dTheta=2*Math.PI/parseInt($("#HScrResolution").val());
    var Theta1=StartingTheta;
    var Theta2=Theta1+dTheta;
    var red=0,green=0,blue=0,dRed=1;
    var X1ToDraw,X2ToDraw,Y1ToDraw,Y2ToDraw;
    while(Theta2<=CurrentNoOfRotations*2*Math.PI){
        X1ToDraw=SpiroX(Theta1);
        X2ToDraw=SpiroX(Theta2);
        Y1ToDraw=SpiroY(Theta1);
        Y2ToDraw=SpiroY(Theta2);
        if(SelectedColorScheme==1){
            cntx.strokeStyle="rgb("+PaletteR[SelectedColorIndex]+","+PaletteG[SelectedColorIndex]+","+PaletteB[SelectedColorIndex]+")";
        }
        else if(SelectedColorScheme==2){
            red=red+dRed;
            if(red==255 || red==0)dRed=-dRed;
            cntx.strokeStyle="rgb("+red+",0,0)";
        }
        else if(SelectedColorScheme==3){
            var d=R+r+Math.max(r,p);
            var Xmin=Xc1-d;
            var Xmax=Xc1+d;
            var Ymin=Yc1-d;
            var ColorA=255/(2*d);
            var ColorBx=-ColorA*Xmin;
            var ColorBy=-ColorA*Ymin;
            red=parseInt(ColorA*X1ToDraw+ColorBx);
            green=parseInt(ColorA*Y1ToDraw+ColorBy);
            blue=0;
            cntx.strokeStyle="rgb("+red+","+green+","+blue+")";
        }
        else if(SelectedColorScheme==4){
            cntx.strokeStyle="rgb("+red+","+green+","+blue+")";
            if(blue<255){
                blue++;
            }
            else if(red<255){
                red++;
            }
            else if(green<255){
                green++;
            }
            else{
                red=0;
                green=0;
                blue=0;
            }
        }
        else if(SelectedColorScheme==5 || SelectedColorScheme==6){
            var RandomIndex=parseInt(Theta1/(2*Math.PI));
            if(SelectedColorScheme==5) RandomIndex=RandomIndex % 2;
            cntx.strokeStyle="rgb("+parseInt(255*RndColors[RandomIndex][0])+","+parseInt(255*RndColors[RandomIndex][1])+","+parseInt(255*RndColors[RandomIndex][2])+")";
        }
        cntx.beginPath();
        cntx.moveTo(X1ToDraw,Y1ToDraw);
        cntx.lineTo(X2ToDraw,Y2ToDraw);
        cntx.stroke();
        Theta1=Theta2;
        Theta2=Theta2+dTheta;
    }
    if(CurrentNoOfRotations>0 && $("#chkShowSpirograph").prop("checked")){
        var PenRadius=3;
        cntx.beginPath();
        cntx.strokeStyle="rgb(150,150,150)";
        cntx.moveTo(Xc1+R,Yc1);
        cntx.arc(Xc1,Yc1,R,0,2*Math.PI);
        cntx.stroke();
        cntx.moveTo(Xc2(Theta1)+r,Yc2(Theta1));
        cntx.arc(Xc2(Theta1),Yc2(Theta1),r,0,2*Math.PI);
        cntx.stroke();
        cntx.moveTo(Xc2(Theta1),Yc2(Theta1));
        cntx.lineTo(SpiroX(Theta1),SpiroY(Theta1));
        cntx.stroke();
        
        cntx.beginPath();
        cntx.fillStyle="rgb("+PaletteR[SelectedColorIndex]+","+PaletteG[SelectedColorIndex]+","+PaletteB[SelectedColorIndex]+")";
        cntx.moveTo(SpiroX(Theta1)+PenRadius,SpiroY(Theta1));
        cntx.arc(SpiroX(Theta1),SpiroY(Theta1),PenRadius,0,2*Math.PI);
        cntx.stroke();
        cntx.strokeStyle="rgb(0,0,0)";
        cntx.moveTo(SpiroX(Theta1)+PenRadius,SpiroY(Theta1));
        cntx.arc(SpiroX(Theta1),SpiroY(Theta1),PenRadius,0,2*Math.PI);
        cntx.fill();
        cntx.stroke();
    }
}

function SpiroX(Theta){
    return parseInt(Xc2(Theta)+p*Math.cos((R+r)*Theta/r));
}

function SpiroY(Theta){
    return parseInt(Yc2(Theta)+p*Math.sin((R+r)*Theta/r));
}

function Xc2(Theta){
    return parseInt((R+r)*Math.cos(Theta)+Xc1);
}

function Yc2(Theta){
    return parseInt((R+r)*Math.sin(Theta)+Yc1);
}

function defineRandomColors(){
    for(var i=0;i<MaxNoOfRotations;i++){
        var newEntry=[];
        for(var j=0;j<3;j++){
            newEntry.push(Math.random());
        }
        RndColors[i]=newEntry;
    }
}